<template>
  <ob-form
    ref="smsCodeForm"
    class="sms-code-form"
    :form-data="formData"
    :form-model="model"
    :is-show-controls="false"
    :is-show-required="false"
  >
    <div class="sms-code-form__text">
      <transition
        name="fadeIn"
        mode="out-in"
      >
        <div v-if="!isErrorCode && attemptCount >= 3">
          Мы отправили на указанный номер пин-код, чтобы убедиться, что это именно ваш телефон.<br>Введите пин-код,
          пожалуйста.
        </div>
        <div v-if="isErrorCode || attemptCount < 3">
          Пин-код введён неверно.<br>
          Перепроверьте пин-код и введите заново.<br>
          Попыток ввода осталось: {{ attemptCount }}
        </div>
      </transition>
    </div>

    <ob-input
      ref="code"
      v-model="formData.code"
      label="Пин-код"
      mask="9999"
      property="code"
      class="sms-code-field"
      :disabled="isDisabledCode"
      :is-valid="isValidCode"
      @on-enter="checkCode"
    />
  </ob-form>
</template>

<script>
import { required } from 'vuelidate/lib/validators'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import ObInput from 'common-components/src/obComponents/obInput'
import ObForm from 'common-components/src/obComponents/obForm'
import api from '@/api'

export default {
  name: 'SmsCodeForm',
  components: { ObForm, ObInput },
  mixins: [
    FormValidationMixin
  ],
  data () {
    return {
      timeout: null,
      attemptCount: 3,
      isErrorCode: undefined,
      pending: false,
      model: {
        code: {
          value: '',
          validator: {
            required
          }
        }
      }
    }
  },
  computed: {
    isDisabledCode () {
      return this.pending
    },
    isValidCode () {
      if (this.isErrorCode === undefined) return null
      return !this.isErrorCode
    }
  },
  watch: {
    'formData.code' (val) {
      if (val) {
        this.checkCode()
      }
    }
  },
  mounted () {
    this.focusInputCode()
  },
  methods: {
    checkCode () {
      this.isErrorCode = undefined
      if (this.$refs.code.isValidMask) {
        this.pending = true
        this.timeout = setTimeout(async () => {
          this.isErrorCode = undefined
          try {
            let phone = this.$parent.formData.phone.replace(/[()\-\s]/g, '')
            phone = phone.replace('+7', '8')
            let res = await api.registration.register.checkPhoneCode({
              phone: phone,
              code: this.formData.code
            })
            this.isErrorCode = false
            setTimeout(() => {
              this.$emit('confirm', { uuid: res.uuid })
            }, 500)
          } catch (e) {
            this.isErrorCode = true
            if (this.attemptCount > 1) {
              this.focusInputCode()
              this.attemptCount--
            } else {
              this.$emit('confirm-error')
            }
          }
          this.pending = false
        }, 1000)
      } else {
        clearTimeout(this.timeout)
        this.$refs.code.touchField()
      }
    },
    getIconByValidateState (state) {
      switch (state) {
        case null:
          return ''
        case true:
          return 'checked'
        case false:
          return 'alert'
      }
    },
    focusInputCode () {
      this.$nextTick(() => {
        if (this.attemptCount !== 3) {
          this.$refs.code.dirty = true
        }
        this.$refs.code.focus()
      })
    },
    clearState () {
      this.timeout = null
      this.attemptCount = 3
      this.isErrorCode = undefined
      this.pending = false
      this.formData.code = null
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/assets/style/ob-style";

  .sms-code-form {
    @include font-mixin(14px, 20px, 400, 0.2px, black);

    &__text {
      margin-top: 20px;
      margin-bottom: 14px;
    }
  }
  
  .sms-code-field {
    max-width: 204px;
  }
</style>
